<?php // Invitation-database functions

function mysql_query_params__callback( $at ) {
	global $mysql_query_params__parameters;
#	return array_key_exists($at[1]-1, $mysql_query_params__parameters) ? $mysql_query_params__parameters[ $at[1]-1 ] : '';
	return $mysql_query_params__parameters[ $at[1]-1 ];
}

function mysql_query_params($link, $query, $parameters=array()) {
	// Escape parameters as required & build parameters for callback function
	global $mysql_query_params__parameters;
	foreach( $parameters as $k=>$v )
		$parameters[$k] = ( is_int( $v ) ? $v : ( NULL===$v ? 'NULL' : "'".mysql_real_escape_string( $v )."'" ) );
		$mysql_query_params__parameters = $parameters;
	return mysql_query( preg_replace_callback( '/\$([0-9]+)/', 'mysql_query_params__callback', $query ), $link);
}

function db_exec_mysql(&$db, $query, $parameters = array()) {
  #if (pg_query_params($db['connection'], $query, array_slice($args, 2)))
  if (mysql_query_params($db['connection'], $query, $parameters))
    return true;
  else
    return false;
}

function db_select_mysql(&$db, $query, $parameters = array()) {
  if ($result = mysql_query_params($db['connection'], $query, $parameters)) {
      $r = array();
      while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) $r[] = $row;
      mysql_free_result($result);
      return $r;
  } else
 	 return -1;
}

function db_connect_mysql(&$db) {
  $host = $db['host'];
  $port = $db['port'];
  $dbname = $db['database'];
  $user = $db['user'];
  $pwd  = $db['password'];

  if(!array_key_exists('requests', $db))
     $db['requests'] = 'requests';
  if(!array_key_exists('invitations', $db))
     $db['invitations'] = 'invitations';

  $link = mysql_connect($host . ':' . $port, $user, $pwd);
  if ($link == FALSE) {
      throw new Exception('MySQL connection failed: ' . mysql_error($link));
  }
  if (mysql_select_db($dbname) == FALSE) {
      throw new Exception('MySQL database selection failed: ' . mysql_error($link));
  }

  $db['connection'] = $link;
  return $db['connection'];
}

function db_exec_postgresql(&$db, $query, $parameters = array()) {
  if (pg_query_params($db['connection'], $query, $parameters))
    return true;
  else
    return false;
}

function db_select_postgresql(&$db, $query, $parameters = array()) {
  if ($result = pg_query_params($db['connection'], $query, $parameters))
    return @pg_fetch_all($result);
  else
    return -1;
}

function db_connect_postgresql(&$db) {
  $host = $db['host'];
  $port = $db['port'];
  $dbname = $db['database'];
  $user = $db['user'];
  $pwd  = $db['password'];

  if(!array_key_exists('requests', $db))
     $db['requests'] = 'requests';
  if(!array_key_exists('invitations', $db))
     $db['invitations'] = 'invitations';

  $db['connection'] = pg_pconnect("host=$host port=$port dbname='$dbname' user='$user' password='$pwd'");

  if ($db['connection'] === FALSE) {
        error_log(pg_last_error());
  } else {
     if(array_key_exists('schema', $db)) {
        $schema = $db['schema'];
        db_exec($db, "SET search_path TO '$schema'");
     }
  }
  return $db['connection'];
}

function db_exec(&$db, $query) {
	global $database_type;
	$args = func_get_args();
	$function = 'db_exec_' . $database_type;
	return $function($db, $query, array_slice($args, 2));
}

function db_select(&$db, $query) {
	global $database_type;
	$args = func_get_args();
	$function = 'db_select_' . $database_type;
	return $function($db, $query, array_slice($args, 2));
}

function db_connect(&$db) {
	global $database_type;
	$function = 'db_connect_' . $database_type;
	return $function($db);
}

?>
